/* Author : Paul Ortyl <ortylp@3miasto.net>
 * License: GPL
 * Version: 0.24C
 * Date   : 28.12.2000
 * Description: see email2SMS.lsm
 * Note   : If you want to be notified of next release
 *           of the script mailto:ortylp@3miasto.net
 * Bug/wish reports : mailto:ortylp@3miasto.net
 */


/* provides two simple LIFO queues */

#include <malloc.h>
#include "list.h"

void spush(struct sitem ** root, char* str)
{
  struct sitem *i; 
  i=calloc(1,sizeof(struct sitem));
  i->next=*root;
  i->str=malloc(strlen(str)+1);
  strcpy(i->str,str);
  *root=i;
}

void sdel(struct sitem ** root)
{
  struct sitem * i;
  if (*root)
    {
      free((*root)->str);
      i=*root;
      *root=i->next; 
      free(i);
    }
}

void ipush(struct iitem ** root, int in)
{
  struct iitem *i; 
  i=calloc(1,sizeof(struct iitem));
  i->next=*root;
  i->i=in;
  *root=i;
}

void idel(struct iitem ** root)
{
  struct iitem * i;
  if (*root)
    {
      i=*root;
      *root=i->next; 
      free(i);
    }
}


/*
main()
{
  char* string="aawe";
  struct litem *root=NULL;
  lpush(&root, "1abcd");
  lpush(&root, "2bcde");
  lpush(&root, "3bcde");
  lpush(&root, "4bcde");
  while((string=lpop(&root)))
    { free(string);}
}
*/
